<template>
	<div
		:id="id"
		:class="[$style.block, featureVariations.optionalTitle ? $style.optionalBlock : '']"
		:style="{ display: hidden === 'Yes' ? 'none' : null }"
		class="u-block-spacing-has-inner u-block-spacing-possibly-touch-previous u-block-spacing-last-no-bottom-spacing"
	>
		<h2 v-if="featureVariations.optionalTitle" class="u-heading" :class="$style.headingOptional">
			{{ featureVariations.optionalTitle }}
		</h2>
		<div :class="$style.row" :style="{ maxWidth: maxWidths.container }">
			<div v-for="(feature, index) in featureVariations.items" :key="index" :class="$style.column">
				<div
					v-if="(feature.iconMobile && feature.iconMobile.url) || (feature.icon && feature.icon.url)"
					:class="$style.image"
				>
					<BaseImage
						:image="feature.iconMobile || {}"
						:images="{ medium: feature.icon || {} }"
						sizes="(min-width: 1024px) 50px, 90px"
						compression-level="high"
					/>
				</div>

				<div :style="{ maxWidth: maxWidths.singleDesktop }" :class="$style.infoWrapper">
					<h2 v-if="feature.heading" class="u-font-secondary" :class="$style.heading">
						{{ feature.heading }}
					</h2>

					<p v-if="feature.description" class="u-copy" :class="$style.description">{{ feature.description }}</p>
				</div>
			</div>
		</div>
	</div>
</template>

<script>
import { mapState } from 'vuex';

export default {
	props: {
		id: {
			type: String,
			default: null,
		},

		variationId: {
			type: String,
			default: 'global',
		},

		hidden: {
			type: String,
			default: 'No',
		},
	},

	computed: {
		...mapState({
			featureVariations(state) {
				const { featureVariations } = state.globalData;
				return featureVariations && featureVariations[this.variationId || 'global'];
			},
		}),

		maxWidths() {
			const featuresData = this.featureVariations;

			const parse = (val, fallback = 'none') => (val ? `${val / 10}rem` : fallback);

			return {
				singleDesktop: parse(featuresData.maxWidthSingleDesktop, '30rem'),
				singleMobile: parse(featuresData.maxWidthSingleMobile, '30rem'),
				container: parse(featuresData.maxWidthContainer, '130rem'),
			};
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.block {
	position: relative;
	padding: size('m') 0;
	color: color('white');
	background-color: color('primary-300');

	@include above('medium') {
		padding: 20.5rem 0 12.5rem;
	}
}

.optionalBlock {
	padding: size('m') 0;

	@include above('medium') {
		padding: 0 0 12.5rem;
	}
}

.row {
	@include above('medium') {
		display: flex;
		justify-content: space-between;
		margin: 0 auto;
	}
}

.column {
	padding: 0 size('s');
	margin-bottom: size('s++');
	text-align: center;

	@include above('medium') {
		padding: 0 size('m+');
		margin-bottom: 0;
	}
}

.image {
	width: 6.8rem;
	margin-right: auto;
	margin-bottom: size('m');
	margin-left: auto;

	@include above('large') {
		width: 6.8rem;
		margin: 0 auto 5.4rem;
	}
}

.infoWrapper {
	margin: 0 auto;
}

.heading {
	margin-bottom: size('s');
	font-weight: 700;

	@include use-text-style('type-200');
	@include font-family('primary');
}

.headingOptional {
	padding: 2rem 0 5rem;
	margin: 0;

	@include above('medium') {
		padding: 10rem 0;
	}
}

.description {
	padding: 0 size('s++');
	line-height: 1.285721;
	color: color('white');
	white-space: pre-line;

	@include use-text-style('type-100');

	@include above('medium') {
		padding: 0;
	}

	@include above('large') {
		margin: 0 0 8rem;
	}
}

:export {
	/* stylelint-disable-next-line property-no-unknown */
	breakpoint: 768;
}
</style>
